class RaceState {
    ActionKey currentActionKey = ActionKey::AK5;
    ActionKey lastCpActionKey = ActionKey::AK5;
    uint lastKeyPress;

    bool IsActionKeyPress(ActionKey actionKey, uint16 pressed) {
        return actionKey & pressed != actionKey & lastKeyPress;
    }

    void OnPressActionKey(ActionKey actionKey) {
        if (actionKey & lastKeyPress > 0)
            return;

        currentActionKey = currentActionKey == actionKey ? ActionKey::AK5 : actionKey;
    }

    void OnCpTaken(CSmPlayer@ player) {
        lastCpActionKey = currentActionKey;
    }

    void OnRespawn() {
        currentActionKey = lastCpActionKey;
    }

    void OnStandingRespawn() {
        currentActionKey = ActionKey::AK5;
    }
}