bool g_settingsMove = false;
UI::Cond g_settingsMoveCond = UI::Cond::Appearing;

[Setting hidden]
bool Setting_AdvancedWidgetSettings = false;

[SettingsTab name="Move/Resize" icon="ArrowsAlt"]
void RenderSettingsWidgets()
{
	g_settingsMove = true;

	UI::TextWrapped("While this tab is open, you can drag the widgets around, resize them.");

    Setting_AdvancedWidgetSettings = UI::Checkbox("Advanced visibility settings", Setting_AdvancedWidgetSettings);

	UI::Separator();

    if (Setting_AdvancedWidgetSettings) {
        if (UI::BeginTable("Widgets", 5)) {
			UI::TableSetupColumn("Widget", UI::TableColumnFlags::WidthStretch, 0.9f);
			UI::TableSetupColumn("Position", UI::TableColumnFlags::WidthFixed, 130);
			UI::TableSetupColumn("Size", UI::TableColumnFlags::WidthFixed, 130);
			UI::TableSetupColumn("Visible UI", UI::TableColumnFlags::WidthFixed, 80);
			UI::TableHeadersRow();

			auto thing = actionKeyVisual;

			UI::PushID(thing);

			UI::TableNextColumn();
			UI::Text(thing.m_name);

			UI::TableNextColumn();
			UI::PushItemWidth(-1);
			thing.m_pos = UI::InputFloat2("##Position", thing.m_pos);
			UI::PopItemWidth();

			UI::TableNextColumn();
			UI::PushItemWidth(-1);
			thing.m_size = UI::InputFloat2("##Size", thing.m_size);
			UI::PopItemWidth();

			UI::TableNextColumn();
			bool whenVisible = UI::Checkbox("##WhenVisible", thing.IsVisible(false));

			thing.SetVisible(whenVisible, false);
			thing.SetProportions(thing.m_pos, thing.m_size);

			UI::PopID();

			UI::EndTable();
		}
    } else {
        bool visible = UI::Checkbox(actionKeyVisual.m_name, actionKeyVisual.IsVisible(false));
        actionKeyVisual.SetVisible(visible, visible);

        if (UI::Button("Reset proportions to defaults")) {
            actionKeyVisual.ResetProportions();
            actionKeyVisual.UpdateProportions();
            // This is required to force the locator windows to reset on the next frame, rather than use the same positions from the last frame
            g_settingsMoveCond = UI::Cond::Always;
        }
    }
}

void RenderInterface()
{
	if (!g_settingsMove) {
		return;
	}

	float scale = UI::GetScale();

	if (actionKeyVisual.IsVisible(true) || actionKeyVisual.IsVisible(false)) {
		actionKeyVisual.UpdateProportions();

		vec2 screenSize = vec2(Draw::GetWidth(), Draw::GetHeight());
		vec2 pos = actionKeyVisual.m_pos * (screenSize - actionKeyVisual.m_size);

		UI::SetNextWindowSize(int(actionKeyVisual.m_size.x / scale), int(actionKeyVisual.m_size.y / scale), g_settingsMoveCond);
		UI::SetNextWindowPos(int(pos.x / scale), int(pos.y / scale), g_settingsMoveCond);

		UI::Begin(Icons::ArrowsAlt + " " + actionKeyVisual.m_name, UI::WindowFlags::NoCollapse | UI::WindowFlags::NoSavedSettings);
		actionKeyVisual.m_size = UI::GetWindowSize();
		actionKeyVisual.m_pos = UI::GetWindowPos() / (screenSize - actionKeyVisual.m_size);
		UI::End();

		actionKeyVisual.SetProportions(actionKeyVisual.m_pos, actionKeyVisual.m_size);
    }

	g_settingsMove = false;
	g_settingsMoveCond = UI::Cond::Appearing;
}
